<?php

spl_autoload_register('fwAutoLoad');

function fwAutoLoad($strIdentifierName){
    switch (true){
        case strpos($strIdentifierName, 'NsFWK') !== false:
            clsLoadFrameWork($strIdentifierName);
            break;
        case strpos($strIdentifierName, 'ClsCtrl') !== false:
            clsLoadCtrl($strIdentifierName);
            break;
    }
}

function clsLoadFrameWork($strIdentifierName){
    $str = substr($strIdentifierName, 0, 1);
    if ($str != '\\'){
        $strIdentifierName = '\\' . $strIdentifierName;
    }

    $arrIdentifier = explode('\\', $strIdentifierName);
    array_shift($arrIdentifier); // remove the empty element due to // prefix
    array_shift($arrIdentifier); // remove the frame work element NsFWK
    $strIdentifier = array_pop($arrIdentifier);

    $strPath = '/';
    if (!empty($arrIdentifier)) {
        foreach ($arrIdentifier as $strPart) {
            $strPath .= getDirName($strPart) . '/';
        }
    }

    $strFileName = getFileName($strIdentifier);
    $strPath = LOCAL__FRAMEWORK . $strPath . $strFileName;
    
    if (file_exists($strPath)) {
        require_once($strPath);
    }
}

function clsLoadCtrl($strIdentifierName){
    // Identifier is a namespace member
    // if $strIdentifierName is not preceded by \, add a leading \
    $str = substr($strIdentifierName, 0, 1);
    if ($str != '\\'){
        $strIdentifierName = '\\' . $strIdentifierName;
    }

    $arrToken = explode('\\', $strIdentifierName);
    array_shift($arrToken); // remove the empty element due to // prefix

    $arrPath = [];
    if (!empty($arrToken)) {
        $intParts = count($arrToken);
        for ($i=0; $i<$intParts; $i++) {
            if ($i == 0) {
                $arrPath[] = LOCAL__MODULES;
            } elseif ($i == 1) {
                $arrPath[] = 'controller';
                $arrFileName = explode('.', getFileName($arrToken[$intParts-1]));
                $arrPath[] = $arrFileName[1];
            }
            
            if ($i < $intParts-1) {
                $arrPath[] = getDirName($arrToken[$i]);
            } else {
                $arrPath[] = getFileName($arrToken[$i]);
            }
        }
    }

    $strConfigPath = implode('/', array_slice($arrPath, 0, 2)) . '/.config.php';
    $strClassPath = implode('/', $arrPath);
    if (file_exists($strConfigPath)) {
        require_once($strConfigPath);
    }
    if (file_exists($strClassPath)) {
        require_once($strClassPath);
    }

    return;

}

function getDirName($strNameSpace){
    $strStartChar = substr($strNameSpace, 0, 2);
    switch ($strStartChar){
        case 'Ns':
            // class
            $strNameSpace = str_replace('Ns', '', $strNameSpace);
            break;
        default:
            return;
    }
    preg_match_all('/(([A-Z])([a-z]+))|(([A-Z]+)(?![a-z])([0-9])*)|([0-9])+/', $strNameSpace, $arrPart);
    $arrDirName = array();
    foreach($arrPart[0] as $part){
        $arrDirName[] = strtolower($part);
    }
    
    $strDirName = implode('.', $arrDirName);
    return $strDirName;
}

function getFileName($strClassName){
    $strStartChar = substr($strClassName, 0, 3);
    switch ($strStartChar){
        case 'Cls':
            // class
            $strClassName = str_replace('Cls', '', $strClassName);
            break;
        case 'Int':
            // interface
            $strClassName = str_replace('Int', '', $strClassName);
            break;
        case 'Trt':
            // trait
            $strClassName = str_replace('Trt', '', $strClassName);
            break;
        default:
            return;
    }

    preg_match_all('/(([A-Z])([a-z]+))|(([A-Z]+)(?![a-z])([0-9])*)|([0-9])+/', $strClassName, $arrPart);
    $arrFileName = array();
    foreach($arrPart[0] as $part){
        $arrFileName[] = strtolower($part);
    }
    $arrFileName[] = 'php'; // for the extension
    
    $strFileName = implode('.', $arrFileName);
    return $strFileName;
}