<?php
namespace NsFWK;
class ClsBllApi
{
    private $_url = '';
    private $_apiKey = '';
    private $_status = '';
    private $_error = '';

    public function __construct($apiUrl, $apiKey){
        $this->_url = $apiUrl;
        $this->_apiKey = $apiKey;
    }

    public function ApiMatch($intMatchId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchLoad",
            "match_id"=>$intMatchId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['data'])){
            return $rslt['data'];
        }
        return false;
    }
    public function ApiMatchVideo($intMatchId, $streamId, $qualityId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchVideo",
            "match_id"=>$intMatchId,
            "stream_id"=>$streamId,
            "quality_id"=>$qualityId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            print $this->_error;
            return false;
        }
        if(isset($rslt['root']['result']) && $rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        return false;
    }

    public function ApiPlayer($intPlayerId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsPlayerLoad",
            "player_id"=>$intPlayerId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['root']['result']) && $rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        return false;
    }

    public function ApiLinkMatch($strWebPath, $intMatchId, $intHalf, $intPlatformId, $intStreamId, $intQualityId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchLink",
            "match_id"=>$intMatchId,
            "half"=>$intHalf,
            "platform_id"=>$intPlatformId,
            "stream_id"=>$intStreamId,
            "quality_id"=>$intQualityId,
            "path"=>$strWebPath,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['root']['result']) && $rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        return false;
    }    
    public function ApiPlayerClipList($intMatchId,$intPlayerID){
        $arrData = [
            "module"=>"api",
            "api"=>"KsPlayerClipList",
            "match_id"=>$intMatchId,
            "player_id"=>$intPlayerID,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['root']['result']) && $rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        return false;
    }    
    public function ApiMatchVideoHalf($intMatchId, $intHalf, $intStreamId, $intQualityId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchHalfVideo",
            "match_id"=>$intMatchId,
            "half"=>$intHalf,
            "stream_id"=>$intStreamId,
            "quality_id"=>$intQualityId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['root']['result']) && $rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        return false;
    }    

    public function ApiMatchEffectiveTime($intMatchId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchEffectiveTime",
            "match_id"=>$intMatchId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        
        if(isset($rslt['root']['result']) && $rslt['root']['result'] == 1){
            return $rslt['root']['object'];
        }
        return false;
    }    


    public function ApiPlatform($intPlatformId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsPlatformLoad",
            "platform_id"=>$intPlatformId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['data'])){
            return $rslt['data'];
        }
        return false;
    }    
    
    public function ApiNotification($intUserId, $strTitle, $strMessage, $strLink=""){
        $arrData = [
            "module"=>"api",
            "api"=>"KsCreateNotification",
            "user_id"=>$intUserId,
            "title"=>$strTitle,
            "message"=>$strMessage,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        if($strLink!=''){
            $arrData['link'] = $strLink;
        }

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if($rslt['result']==='Success'){
            return true;
        }
        return false;
    }

    public function ApiActivity($intUserId, $strActivityType, $intCount = 1){
        $arrData = [
            "module"=>"api",
            "api"=>"KsRecordActivity",
            "user_id"=>$intUserId,
            "activity_type"=>$strActivityType,
            "count"=>$intCount,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if($rslt['result']==='Success'){
            return true;
        }
        return false;
    }


    public function ApiStream($intStreamId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsStreamLoad",
            "stream_id"=>$intStreamId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['data'])){
            return $rslt['data'];
        }
        return false;
    }


    /**
     * Call the quality Id remotely.
     *
     * @param integer $intWidth
     * @param integer $intHeight
     * @param bool $boolCreateIfNotExist: if true this will call add Quality if not exist.
     * @return array of data otherwise false
     */
    public function ApiQuality(int $intWidth, int $intHeight, bool $boolCreateIfNotExist = false){
        $arrData = [
            "module"=>"api",
            "api"=>"KsQualityLoad",
            "width"=>$intWidth,
            "height"=>$intHeight,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            $rslt = $this->ApiCreateQuality($intWidth, $intHeight);
            if($rslt===false){
                return false;
            }
            return $rslt;
        }
        if(isset($rslt['data'])){
            return $rslt['data'];
        }
        return false;
    }

    /**
     * Call the quality Id remotely.
     *
     * @param integer $intWidth
     * @param integer $intHeight
     * @param bool $boolCreateIfNotExist: if true this will call add Quality if not exist.
     * @return array of data otherwise false
     */
    public function ApiStreamList(int $intMatchId, int $intHalf){
        $arrData = [
            "module"=>"api",
            "api"=>"KsStreamList",
            "match_id"=>$intMatchId,
            "half"=>$intHalf,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);

        if($rslt===false){
            return false;
        }
        if((bool)$rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        $this->_error = $rslt['root']['message'];
        return false;
    }

    public function ApiBestQuality($intMatchId, $intHalf, $intStreamId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsQualityBest",
            "match_id"=>$intMatchId,
            "half"=>$intHalf,
            "stream_id"=>$intStreamId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];


        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if((bool)$rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        $this->_error = $rslt['root']['message'];
        return false;
    }

    public function ApiVideoLoad($intStreamId, $intQualityId, $intMatchId, $intHalf){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchHalfVideo",
            "match_id"=>$intMatchId,
            "half"=>$intHalf,
            "stream_id"=>$intStreamId,
            "quality_id"=>$intQualityId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];

        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if((bool)$rslt['root']['result']==1){
            return $rslt['root']['object'];
        }
        $this->_error = $rslt['root']['message'];
        return false;
    }

    public function ApiCreateQuality($intWidth, $intHeight){
        $arrData = [
            "module"=>"api",
            "api"=>"KsQualityAdd",
            "width"=>$intWidth,
            "height"=>$intHeight,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }
        if(isset($rslt['data'])){
            return $rslt['data'];
        }
        return false;
    }    

    public function ApiMatchHighlight($intMatchId, $intStreamId, $intQualityId){
        $arrData = [
            "module"=>"api",
            "api"=>"KsMatchHighlights",
            "match_id"=>$intMatchId,
            "stream_id"=>$intStreamId,
            "quality_id"=>$intQualityId,
            "key"=>$this->_apiKey,
            "response"=>"JSON",
            "version"=>"V2"
        ];
        $rslt = $this->call('POST', $arrData);
        if($rslt===false){
            return false;
        }

        if(isset($rslt['root']['object'])){
            return $rslt['root']['object'];
        }
        return false;

    }


    private function call($strMethod, $arrParam){
        try {
            $client = new \GuzzleHttp\Client();
            $arrFormParams = ["form_params" => $arrParam];
            switch($strMethod){
                case('POST'):
                    $response = $client->post($this->_url, $arrFormParams);
                    break;
                case('PUT'):
                    $response = $client->put($this->_url, $arrFormParams);
                    break;
                case('GET'):
                    $response = $client->get($this->_url, $arrFormParams);
                    break;
                case('PATCH'):
                    $response = $client->patch($this->_url, $arrFormParams);
                    break;
                case('DELETE'):
                    $response = $client->delete($this->_url, $arrFormParams);
                    break;            
            }            
            $statusCode = $response->getStatusCode();
            $body = $response->getBody()->getContents();
            $arr = json_decode($body, true);
            // Check for JSON decoding errors
            if (json_last_error() !== JSON_ERROR_NONE) {
                // Return or handle the error as needed
                $this->_error = $body;
                return false;
            }
    
            // You may also want to check if the response HTTP status code indicates an error
            $statusCode = $response->getStatusCode();
            if ($statusCode < 200 || $statusCode >= 300) {
                $this->_status = $statusCode;
                $this->_error = $arr;
                return false;
            }    
            return $arr;
        } catch (\GuzzleHttp\Exception\GuzzleException $e) {
            $this->_error = $e->getMessage();
            return false;
        }
        


    }

    static public function Sendmail($intMatchId, $strErrorMessage){

        $strServerIP = \NsFWK\ClsHlpHelper::GetServerIP();
        $strErrorMessage = "Source Server: {$strServerIP} <br/>" . $strErrorMessage;
        $arrVars = [
            'match_id'=>$intMatchId,
            'error_message'=>$strErrorMessage
        ];

        $arrEmailTo = [SMTP2GO_MAIL_ERRORS];
        $obj = new \NsFWK\ClsSmtpToGo();
        $rslt = $obj->Send($arrEmailTo, SMTP2GO_MAIL_SYSTEM, SMTP2GO_TEMPLATE_MATCH_ERROR, $arrVars, SMTP2GO_MAIL_SYSTEM);        
        if($rslt==true){
            return true;
        }
        return false;
    }    
}