<?php
namespace NsFWK;
class ClsBllEventEmitter {

    private $listeners = [];

    // Register an event listener
    public function on($event, callable $listener) {
        if (!isset($this->listeners[$event])) {
            $this->listeners[$event] = [];
        }
        $this->listeners[$event][] = $listener;
    }

    // Trigger (raise) an event
    public function emit($event, ...$args) {
        if (isset($this->listeners[$event])) {
            foreach ($this->listeners[$event] as $listener) {
                call_user_func_array($listener, $args);
            }
        }
    }
}