<?php
namespace NsFWK;

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;

class ClsBllRabbitMq
{
    private $_host = RABBITMQ_HOST;
    private $_port = RABBITMQ_PORT;
    private $_user = RABBITMQ_USER;
    private $_pass = RABBITMQ_PASSWORD;
    private $_vhost = RABBITMQ_VHOST;   
    private $_connection = '';
    private $_channel = '';
    private $_queue = '';

    public function __construct($strQueueName){
        $this->_connection = new AMQPStreamConnection($this->_host, $this->_port, $this->_user, $this->_pass, $this->_vhost);
        $this->_channel = $this->_connection->channel();
        $this->_queue = $strQueueName;
        $this->_channel->queue_declare($this->_queue, false, true, false, false);        
    }

    /**
     * This sends the message to the queue.
     *
     * @param [type] $arrData
     * @param [type] $intUserID
     * @return string JobID
     */
    public function Send($arrData, $intUserID){
        $dt = date("Ymd-His");
        $strJobID = "job-id-{$intUserID}-$dt";
        $arrData['jobId'] = $strJobID;
        $strMessage = json_encode($arrData);
        $objMessage = new AMQPMessage($strMessage);
        $this->_channel->basic_publish($objMessage, '', $this->_queue);

        $this->SetJobIdInRedis($strJobID, $arrData);
        return $strJobID;
    }


    private function SetJobIdInRedis($strJobID, $arrValue){
        $obj = new \NsFWK\ClsBllRedis();

        $arrJob['id'] = $strJobID;
        $arrJob['progress'] = 0;
        $arrJob['message'] = 'Initiated';
        $arrJob['type'] = 'info';
        $arrJob['title'] = $arrValue['title'];

        $obj->SetValue($strJobID, $arrJob);
    }

    public function Receive(){
        $message = null;    
        $callback = function ($msg) use (&$message) {
            echo " [x] Received ", $msg->body, "\n";
            $message = $msg->body;
            $msg->delivery_info['channel']->basic_ack($msg->delivery_info['delivery_tag']);
            $msg->delivery_info['channel']->basic_cancel($msg->delivery_info['consumer_tag']); // Cancel consumer to stop consuming
        };
    
        $this->_channel->basic_consume($this->_queue, '', false, false, false, false, $callback);
    
        while ($this->_channel->is_consuming() && $message === null) {
            $this->_channel->wait();
        }
        
        return $message;
    }
    

    public function __destruct(){
        $this->_channel->close();
        $this->_connection->close();
    }
}



