<?php
namespace NsFWK;

class ClsBllVideoStreamCopy extends \FFMpeg\Format\Video\DefaultVideo implements \FFMpeg\Format\VideoInterface
{
    protected $videoCodec;
    protected $audioCodec;
    protected $kiloBitrate;
    protected $audioKiloBitrate;
    protected $additionalParameters;
    protected $audioChannels;
    protected $audioSamplerate;

    public function __construct()
    {
        $this->setVideoCodec('h264_nvenc');
        $this->setAudioCodec('copy');
        $this->setAdditionalParameters(['-hwaccel' => 'cuda', '-c:v' => 'h264_nvenc']);
        $this->kiloBitrate = 1000;
        $this->audioKiloBitrate = 128;
    }

    public function getAvailableAudioCodecs()
    {
        return ['copy'];
    }

    public function getAvailableVideoCodecs()
    {
        return ['h264_nvenc'];
    }

    public function getVideoCodec()
    {
        return $this->videoCodec;
    }

    public function setVideoCodec($codec)
    {
        $this->videoCodec = $codec;
        return $this;
    }

    public function getAudioCodec()
    {
        return $this->audioCodec;
    }

    public function setAudioCodec($codec)
    {
        $this->audioCodec = $codec;
        return $this;
    }

    public function getKiloBitrate()
    {
        return $this->kiloBitrate;
    }

    public function setKiloBitrate($kiloBitrate)
    {
        $this->kiloBitrate = $kiloBitrate;
        return $this;
    }

    public function getModulus()
    {
        return 16;
    }

    public function getAdditionalParameters()
    {
        return $this->additionalParameters;
    }

    public function setAdditionalParameters($parameters)
    {
        $this->additionalParameters = $parameters;
        return $this;
    }

    public function getAudioKiloBitrate()
    {
        return $this->audioKiloBitrate;
    }

    public function setAudioKiloBitrate($kiloBitrate)
    {
        $this->audioKiloBitrate = $kiloBitrate;
        return $this;
    }

    public function getVideoBitrate()
    {
        return $this->kiloBitrate;
    }

    public function getAudioChannels()
    {
        return $this->audioChannels;
    }

    public function setAudioChannels($channels)
    {
        $this->audioChannels = $channels;
        return $this;
    }

    public function getAudioSamplerate()
    {
        return $this->audioSamplerate;
    }

    public function setAudioSamplerate($samplerate)
    {
        $this->audioSamplerate = $samplerate;
        return $this;
    }

    public function supportBFrames()
    {
        return true; // Set this according to your needs
    }
}




//namespace NsFWK;

// class ClsBllVideoStreamCopy extends \FFMpeg\Format\Video\DefaultVideo
// {
//     public function __construct()
//     {
//         $this->setVideoCodec('copy');
//         $this->setAudioCodec('copy');
//     }

//     public function supportBFrames()
//     {
//         return false;
//     }


//     public function getAvailableVideoCodecs()
//     {
//         return ['copy'];
//     }

//     public function getAvailableAudioCodecs()
//     {
//         return ['copy'];
//     }

    
// }
