<?php
namespace NsFWK;

abstract class ClsCtrl extends ClsBase{
    const TYPE_CRON = 'cron';
    
    protected $_payload;
    protected $_section;

    abstract protected function do_Default();

    public function __get($name){
        return parent::__get($name);
    }

    public function __construct($arrParameters){
        $this->_data = $arrParameters;
        $this->_raw = file_get_contents("php://input",false);
        $this->_payload = json_decode(file_get_contents('php://input'), true);

        $this->logCtrlCall();
    }


   
    protected function logCtrlCall(){
        if(isset($_SERVER['HTTP_USER_AGENT']) && isset($_SERVER['REMOTE_ADDR'])){
            $strLog =  "New call by User Agent: [{$_SERVER['HTTP_USER_AGENT']}] - FROM IP Address [".$_SERVER['REMOTE_ADDR']."]";
        }else{
            $strLog =  "New call by API or Command Line";
        }

        \NsFWK\ClsLogger::GetInstance()->LogDebug($strLog);
        $strLog = "Parameters: " . json_encode($this->_data);
        \NsFWK\ClsLogger::GetInstance()->LogDebug($strLog);
        $strLog = "PayLoad: " . json_encode($this->_payload);
        \NsFWK\ClsLogger::GetInstance()->LogDebug($strLog);
    }

   
    public function DoAction(){
        if(key_exists('action', $this->_data)){
            $fnAction = "do_".$this->_data['action'];
            $fnBefore = "before_".$this->_data['action'];
            $fnAfter  = "after_".$this->_data['action'];
        }else{
            $fnAction = 'do_Default';
            $fnBefore = "before_Default";
            $fnAfter  = "after_Default";
        }

        if(method_exists($this, $fnBefore)){
            \NsFWK\ClsLogger::GetInstance()->LogDebug("Calling: $fnBefore()");
            $this->$fnBefore();
        }

        if(method_exists($this, $fnAction)){
            \NsFWK\ClsLogger::GetInstance()->LogDebug("Calling: $fnAction()");
            $this->$fnAction();
        }else{
            return false;
        }

        if(method_exists($this, $fnAfter)){
            \NsFWK\ClsLogger::GetInstance()->LogDebug("Calling: $fnAfter()");
            $this->$fnAfter();
        }

        return true;
    }
}