<?php
namespace NsFWK;

Class ClsHlpHelper{

    public static function IsIE(){
        if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false))
            return true;
        else
            return false;
    }

    public static function GetCurFileName(){
        $currentFile = $_SERVER["SCRIPT_NAME"];
        $parts = Explode('/', $currentFile);
        $currentFile = $parts[count($parts) - 1];
        return $currentFile;
    }

    public static function GeneratePassword($length = 8){
        $tmp = substr(md5(rand().rand()), 0, $length);
        return strtolower($tmp);
    }

    public static function GenerateColors($count){
        $arrRslt = array();
        for($i=0;$i<$count;$i++){
            $r = dechex(mt_rand(100,200)); // generate the red component
            $g = dechex(mt_rand(100,200)); // generate the green component
            $b = dechex(mt_rand(100,200)); // generate the blue component
            $rgb = $r.$g.$b;
            array_push($arrRslt, $rgb);
        }
        return $arrRslt;
    }

    public static function Rgb2Hex($rgb) {
        list($r,$g,$b) = explode(",", $rgb);
        if ($r=='0'){
            $r = '0'.dechex($r);
        }else{
            $r = dechex($r);
        }

        if ($g=='0'){
            $g = '0'.dechex($g);
        }else{
            $g = dechex($g);
        }

        if ($b=='0'){
            $b = '0'.dechex($b);
        }else{
            $b = dechex($b);
        }

        $hex = $r . $g . $b;
        return $hex;
    }

    /**
    * Compare two dates
    * 
    * @param mixed $dtDate1
    * @param mixed $dtDate2
    * @return integer -1: $dtDate1 is null
    * @return integer -2: $dtDate2 is null
    * @return integer -3: $dtDate1 is null and $dtDate2 is null
    * @return integer 1: $dtDate1 is greater than $dtDate2
    * @return integer 2: $dtDate2 is greater than $dtDate1
    * @return integer 3: Both dates are equal
    */
    public static function CompareDates($dtDate1, $dtDate2){
        $dt1 = strtotime($dtDate1); 
        $dt2 = strtotime($dtDate2); 
        switch(true){
            case($dt1==null && $dt2==null):
                return -3;
                break;
            case($dt1==null):
                return -1;
                break;
            case($dt2==null):
                return -2;
                break;
            case($dt1>$dt2):
                return 1;
                break;
            case($dt1<$dt2):
                return 2;
                break;
            case($dt1==$dt1):
                return 3;
                break;
        }
        return false;
    }

    public static function GetAge($birthday){
        list($year,$month,$day) = explode("-",$birthday);
        $year_diff  = date("Y") - $year;
        $month_diff = date("m") - $month;
        $day_diff   = date("d") - $day;

        if ($month_diff < 0){
            $year_diff--;
        }

        if($year_diff < 1){
            if($month_diff == 1){
                $day_diff = ($day_diff<0)? ($day_diff+30) : $day_diff;
                return $day_diff . ' D';
            }else{
                if($day_diff<0){
                    $month_diff--;
                    $day_diff = ($day_diff<0)? ($day_diff+30) : $day_diff;
                }
                $month_diff = ($month_diff<0)? ($month_diff+12) : $month_diff;
                return $month_diff . ' M,' . $day_diff . ' D';
            }
        }else{
            if($year_diff == 1){
                $month_diff = ($month_diff<0)? ($month_diff+12) : $month_diff;
                return $year_diff . ' Y, ' . $month_diff . " M";
            }else{
                return $year_diff . ' Y';
            }
        }
    }

    public static function ValidateDate($strDate, $boolValidateTime = true){
        $arr = explode(" ", $strDate);
        $arrDate = explode("-", $arr[0]);
        if(count($arrDate) < 3){
            return false;
        }
        $rslt = checkdate($arrDate[1], $arrDate[2], $arrDate[0]);
        if(!$rslt){
            return false;
        }
        if($boolValidateTime){
            if(!isset($arr[1])){
                return false;
            }      
            if(!strtotime($arr[1])){
                return false;
            }
        }
        return true;
    }

    public static function NumberOfDaysInMonth($intMonth=false, $intYear=false, $dtDate=false){
        if($intMonth && $intYear){
            $intY = $intYear;
            $intM = $intMonth;
        }elseif($dtDate){
            $intY = date('Y', strtotime($dtDate));
            $intM = date('n', strtotime($dtDate));
        }else{
            $intY = date('Y');
            $intM = date('n');
        }

        return cal_days_in_month(CAL_GREGORIAN, $intM, $intY);
    }

    public static function AddMonthsToDate($tsDate = '', $intNumberOfMonths = 1){
        if(empty($tsDate)){
            $tsDate = strtotime(date("Y-m-d"));
        }

        $intCurDay = date("d", $tsDate);
        $intCurMonth = date("m", $tsDate);
        $intCurYear = date("Y", $tsDate);
        $strTime = date('H:i:s', $tsDate);

        $intNextMonth = $intCurMonth+$intNumberOfMonths;
        if($intNextMonth > 12){
            $intNextMonthYear = $intCurYear + 1;
            $intNextMonth = $intNextMonth % 12;
        }else{
            $intNextMonthYear = $intCurYear;
        }

        $intNextMonthDays = date("t", strtotime("$intNextMonthYear-$intNextMonth-01"));

        if($intCurDay > $intNextMonthDays){
            return strtotime("$intNextMonthYear-$intNextMonth-$intNextMonthDays $strTime");            
        }else{
            return strtotime("$intNextMonthYear-$intNextMonth-$intCurDay $strTime");
        }
    }        


    public static function ArrayToCSV($array, $header_row = true, $col_sep = ",", $row_sep = "\n", $qut = '"'){
        if (!is_array($array) or !is_array($array[0])) return false;
        $output = '';
        //Header row.
        if ($header_row)
        {
            foreach ($array[0] as $key => $val)
            {
                //Escaping quotes.
                $key = str_replace($qut, "$qut$qut", $key);
                $output .= "$col_sep$qut$key$qut";
            }
            $output = substr($output, 1)."\n";
        }
        //Data rows.
        foreach ($array as $key => $val)
        {
            $tmp = '';
            foreach ($val as $cell_key => $cell_val)
            {
                //Escaping quotes.
                $cell_val = str_replace($qut, "$qut$qut", $cell_val);
                $tmp .= "$col_sep$qut$cell_val$qut";
            }
            $output .= substr($tmp, 1).$row_sep;
        }

        return $output;
    }

    public static function Save2File($strFilename, $strContent, $srcFileDirectory, $strWebPath){
        $strFilename = "tmp__".date("YmdHis")."__".$strFilename;
        $strLocal ="$srcFileDirectory/$strFilename";
        $strUrl = "$strWebPath/$strFilename";
        $objFile = fopen($strLocal, "w");
        if ($objFile===false){
            return false;
        }
        fwrite($objFile, $strContent);
        fclose($objFile);
        return $strUrl;
    }

    public static function CSVToArray($strFileName, $strSeparator="|", $boolIncldeHeader = true){
        $intRowNumber = 0;
        $arrResult = array();
        $arrHeaders = array();
        $boolHeaderRow = true;
        if (($handle = fopen($strFileName, "r")) !== FALSE) {
            while (($data = fgetcsv($handle, 1000, $strSeparator)) !== FALSE){
                $intRowLength = count($data);
                if(count($data) == 1 && empty($data[0])){
                    continue;
                }
                $arr = array();
                for ($index=0; $index < $intRowLength; $index++){
                    if($intRowNumber === 0 && $boolIncldeHeader){
                        $arrHeaders[] = $data[$index];
                    }elseif($intRowNumber > 0 && $boolIncldeHeader){
                        $strHeader = $arrHeaders[$index];
                        $arr[$strHeader] = $data[$index];    
                    }else{
                        $arr[] = $data[$index]; 
                    }
                }
                if($intRowNumber > 0){
                    $arrResult[] = $arr;    
                }
                $intRowNumber++;
            }
            fclose($handle);
        }
        return $arrResult;    
    }


    public static function Arabization($text){
        $strTemp = $text;
        $arrCharacters = array(
            'ا'=>array('أ','آ','إ'),
            'ى'=>array('ي'),
            'عبد'=>array('عبد ') // removes trailing spaces between عبد and trailing word
        );
        foreach($arrCharacters as $key=>$arr){
            foreach($arr as $char){
                $strTemp = str_replace($char,$key,$strTemp);        
            }
        }
        return $strTemp;
    }

    public static function IsOdd($intNumber){
        if ($intNumber % 2 == 0) {
            return false; //Number is Even
        }
        return true; //Number is odd
    }

    public static function GetBrowserAgent(){ 
        $u_agent = '';
        if(isset($_SERVER['HTTP_USER_AGENT'])){
            $u_agent = $_SERVER['HTTP_USER_AGENT']; 
        }
        
        $bname = 'Unknown';
        $platform = 'Unknown';
        $version= "";

        //First get the platform?
        $u_agent = $u_agent ?? '';
        if (preg_match('/linux/i', $u_agent)){
            $platform = 'linux';
        }elseif (preg_match('/macintosh|mac os x/i', $u_agent)){
            $platform = 'mac';
        }elseif (preg_match('/windows|win32/i', $u_agent)){
            $platform = 'windows';
        }

        // Next get the name of the useragent yes seperately and for good reason
        if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)){ 
            $bname = 'Internet Explorer'; 
            $ub = "MSIE"; 
        }elseif(preg_match('/Firefox/i',$u_agent)){ 
            $bname = 'Mozilla Firefox'; 
            $ub = "Firefox"; 
        }elseif(preg_match('/Chrome/i',$u_agent)){ 
            $bname = 'Google Chrome'; 
            $ub = "Chrome"; 
        }elseif(preg_match('/Safari/i',$u_agent)){ 
            $bname = 'Apple Safari'; 
            $ub = "Safari"; 
        }elseif(preg_match('/Opera/i',$u_agent)){ 
            $bname = 'Opera'; 
            $ub = "Opera"; 
        }elseif(preg_match('/Netscape/i',$u_agent)){ 
            $bname = 'Netscape'; 
            $ub = "Netscape"; 
        } 

        // finally get the correct version number
        $ub = $ub ?? '';
        $known = array('Version', $ub, 'other');
        $pattern = '#(?<browser>' . join('|', $known) . ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';

        $u_agent = $u_agent ?? '';

        if(!preg_match_all($pattern, $u_agent, $matches)){
            // we have no matching number just continue
        }

        // see how many we have
        $i = count($matches['browser']);
        if($i != 1){
            //we will have two since we are not using 'other' argument yet
            //see if version is before or after the name
            $u_agent = $u_agent ?? '';
            $ub = $ub ?? '';
            if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
                $version= $matches['version'][0];
            }else{
                if(count($matches['version'])>=2){
                    $version= $matches['version'][1];
                };
                
            }
        }else{
            $version= $matches['version'][0];
        }

        // check if we have a number
        if ($version==null || $version=="") {$version="?";}

        return array('userAgent'=>$u_agent,
            'name'=>$bname,
            'version'=>$version,
            'platform'=>$platform,
            'pattern'=>$pattern);
    }

    public static function GUID(){
        if (function_exists('com_create_guid')){
            $guid = com_create_guid();
            $guid = substr($guid,1,strlen($guid)-2);
            return $guid;
        }else{
            mt_srand((double)microtime()*10000);//optional for php 4.2.0 and up.
            $charid = strtoupper(md5(uniqid(rand(), true)));
            $hyphen = chr(45);// "-"
            $uuid = substr($charid, 0, 8).$hyphen
            .substr($charid, 8, 4).$hyphen
            .substr($charid,12, 4).$hyphen
            .substr($charid,16, 4).$hyphen
            .substr($charid,20,12);
            return $uuid;
        }
    }

    public static function ReturnBytes($val) {
        $val = trim($val);
        $last = strtolower($val[strlen($val)-1]);
        switch($last) {
            // The 'G' modifier is available since PHP 5.1.0
            case 'g':
                $val *= 1024;
            case 'm':
                $val *= 1024;
            case 'k':
                $val *= 1024;
        }

        return $val;
    }        

    public static function SaveBase64File($filename, $content, $targetLocalPath, $targetWebPath=''){
        $index = stripos($content,'base64')+ 7;
        if ($index==7){
            //Mime type not sent
            $fileContent = base64_decode($content);
        }else{
            //Mime type sent
            $fileContent = base64_decode(substr($content,$index));
        }
        $tmp = $targetLocalPath.'/'.$filename;

        $rslt = file_put_contents($tmp, $fileContent);
        if ($rslt==false){
            return false;
        }else{
            if($targetWebPath==''){
                return true;
            }else{
                return $targetWebPath.'/'. $filename;    
            }
        }
    }


    public static function CallCron($strCLIPath, $strCronPath, $strModule, $strCron, $arrParams, $strJobDetails = ',') {
        \NsFWK\ClsLogger::GetInstance()->logDebug("Welcome to CallCron");
        $strCronPath .= '/cron.php';
        // Construct command
        if (!empty($arrParams)) {
            $strParams = implode("' '", $arrParams);
            $strParams = "'{$strParams}'";
            $cmd = "{$strCLIPath} -q {$strCronPath} {$strModule} {$strCron} '{$strJobDetails}' {$strParams}";
        } else {
            $cmd = "{$strCLIPath} -q {$strCronPath} {$strModule} {$strCron} '{$strJobDetails}'";
        }
        \NsFWK\ClsLogger::GetInstance()->logDebug($cmd);
        // Run command
        exec($cmd);
    }


    public static function Clean($string) {
        return preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
     }

    public static function StripSQLSpecialChar($strToken){

        $strToken = str_replace(chr(92), chr(92).chr(92).chr(92).chr(92), $strToken);
        $strToken = str_replace("'", "\'", $strToken);
        $strToken = str_replace('"', '\"', $strToken);
        return $strToken;
    }


    public static function IndexObjectArray($arrData, $arrIndexAttribute, $boolArrayOfArray = false, $strIndexAttributeSeparator = '-'){
        if(empty($arrData)){
            return array();
        }
        if(empty($arrIndexAttribute)){
            return array();
        }

        $arrRslt = array();
        foreach($arrData as $objItem){
            $arrIndex = array();
            foreach($arrIndexAttribute as $strAttribute){
                if(isset($objItem->$strAttribute)){
                    $arrIndex[] = $objItem->$strAttribute;
                }
            }
            $strIndex = implode($strIndexAttributeSeparator, $arrIndex);
            if($boolArrayOfArray){
                $arrRslt[$strIndex][] = $objItem;
            }else{
                $arrRslt[$strIndex] = $objItem;
            }
        }
        return $arrRslt;
    }

    public static function IndexObjectArrayAssoc($arrData, $arrIndexAttribute, $boolArrayOfArray = false, $strIndexAttributeSeparator = '-'){
        if(empty($arrData)){
            return array();
        }
        if(empty($arrIndexAttribute)){
            return array();
        }

        $arrRslt = array();
        foreach($arrData as $arrItem){
            $arrIndex = array();
            foreach($arrIndexAttribute as $strAttribute){
                if(isset($arrItem[$strAttribute])){
                    $arrIndex[] = $arrItem[$strAttribute];
                }
            }
            $strIndex = implode($strIndexAttributeSeparator, $arrIndex);
            if($boolArrayOfArray){
                $arrRslt[$strIndex][] = $arrItem;
            }else{
                $arrRslt[$strIndex] = $arrItem;
            }
        }
        return $arrRslt;
    }

    public static function FormatSecToTime($decSecond){
        $intTimeMinutes = floor($decSecond/60);
        $intTimeSeconds = $decSecond % 60;
        $intMilliSeconds = $decSecond - ($intTimeMinutes*60+$intTimeSeconds);
        $intTimeSeconds = $intTimeSeconds+$intMilliSeconds;
        $temp = sprintf("%02d:%02d", $intTimeMinutes, $intTimeSeconds);    
        return $temp;
    }

    public static function ConvertArrayToObject($arr){
        $objE = new \stdClass();
        foreach($arr as $key=>$value){
            $objE->$key = $value;
        }
        return $objE;
    }


    public static function CalculateRate($intNominator, $intDenominator){
        $decRate = 0;
        if ($intDenominator>0){
            $decRate = round($intNominator/$intDenominator,2);
        }
        return $decRate;
    }
    public static function CalculateAccuracy($intTotal, $intSuccess){
        $decAccuracy = 0;
        if ($intTotal>0){
            $decAccuracy = round($intSuccess/$intTotal,2);
        }
        return $decAccuracy;
    }

    public static function FormatSecToMinutes($intSec){
        $intMinutes = floor((int)$intSec/60);
        $intSeconds = $intSec % 60;
        $strMin = str_pad($intMinutes,2,"0",STR_PAD_LEFT);
        $strSec = str_pad($intSeconds,2,"0",STR_PAD_LEFT);
        $strTime = $strMin . ":" . $strSec;
        return $strTime;        
    }

    public static function ConvertDate($strDateTime){
        $objDate = new \DateTime($strDateTime);
        return $objDate;
    }

    public static function DeleteDirectory($strDirectoryPath){
        if(is_dir($strDirectoryPath)){
            $arrFiles = glob($strDirectoryPath . '*', GLOB_MARK); //GLOB_MARK adds a slash to directories returned
            foreach($arrFiles as $strFile){
                self::DeleteDirectory($strFile);      
            }
            rmdir($strDirectoryPath);
        }elseif(is_file($strDirectoryPath)){
            unlink($strDirectoryPath);  
        }
    }

    public static function GetClientIP() {
        if (isset($_SERVER['REMOTE_ADDR'])) {
            return $_SERVER['REMOTE_ADDR'];
        }
        
        return '::1';
    }

    public static function GenerateUID($prefix = '', $more_entropy = false) {
        return uniqid($prefix, $more_entropy);
    }

    public static function RemoveDirectory($directory, $delete_parent = null){
        if(!is_dir($directory)){
            return true;
        }
        $files = glob($directory . '/{,.}[!.,!..]*',GLOB_MARK|GLOB_BRACE);
        foreach ($files as $file) {
          if (is_dir($file)) {
            self::RemoveDirectory($file, 1);
          } else {
            unlink($file);
          }
        }
        if ($delete_parent) {
          rmdir($directory);
        }
      }

      static public function GetServerIP(){
        $strServerName = shell_exec("/sbin/ifconfig | grep 'inet ' | grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $2}'");
        return $strServerName;
      }

      static public function GetServerName(){
        $strServerName = self::GetServerIP();
        $strServerName = str_replace(".", "_", $strServerName);
        $strServerName = "Tag__{$strServerName}";
        return $strServerName;
    }

        // Helper function to resolve relative URLs
    static public function ResolveUrl($baseUrl, $relativeUrl) {
        // If the URL is already absolute, return it
        if (parse_url($relativeUrl, PHP_URL_SCHEME) != '') {
            return $relativeUrl;
        }
    
        // Parse base URL and build path
        $parts = parse_url($baseUrl);
        $path = dirname($parts['path']) . '/' . $relativeUrl;
        $path = str_replace('/./', '/', $path);

        while (strpos($path, '/../') > 0) {
            $path = preg_replace('#/[^/]+/\.\./#', '/', $path);
        }
    
        // Rebuild the URL including the new path
        $port = '';
        if(isset($parts['port'])){
            $port =  ':' . $parts['port'];
        }
        //return $parts['scheme'] . '://' . $parts['host'] . ($parts['port'] ? ':' . $parts['port'] : '') . $path;
        return $parts['scheme'] . '://' . $parts['host'] . $port . $path;
    }

    static public function RemoveExtraSlashes($url) {
        // This pattern matches '//' that are not part of 'http://' or 'https://'
        $pattern = '#(?<!:)//+#';
        $replacement = '/';

        // Replace '//' with '/' when it is not part of 'http://' or 'https://'
        $cleanedUrl = preg_replace($pattern, $replacement, $url);

        return $cleanedUrl;
    }

    static public function CastValues(&$array) {
        foreach ($array as &$value) {
            if (is_array($value)) {
                self::CastValues($value); // Recursive call for nested arrays
            } else {
                if (is_numeric($value)) {
                    if (strpos($value, '.') !== false) {
                        $value = (float) $value; // Cast to float if there's a decimal point
                    } else {
                        $value = (int) $value; // Cast to integer otherwise
                    }
                } elseif (preg_match('/^\d+\/\d+$/', $value)) {
                    // Check for fractional values like "25/1"
                    list($numerator, $denominator) = explode('/', $value);
                    $value = (float) $numerator / (float) $denominator; // Convert fraction to float
                }
            }
        }
    }

    public static function CreateFolder($strPath){
        if (!is_dir($strPath)) {
            mkdir($strPath, 0755, true);
        }

    }

}