<?php

/* 
* This class has been based on the orginal code by Kenneth Katzgaru.
* I'm keeping the original comment for copyrights
* Mostafa Zakaria
*  
* Finally, A light, permissions-checking logging class. 
* 
* Author    : Kenneth Katzgrau < katzgrau@gmail.com >
* Date      : July 26, 2008
* Comments  : Originally written for use with wpSearch
* Website   : http://codefury.net
* Version   : 1.0
*
* Usage: 
*        $log = new ClsLogger("log.txt", self::LEVEL_INFO);
*        $log->LogInfo("Returned a million search results");    //Prints to the log file
*        $log->LogFATAL("Oh dear.");                //Prints to the log file
*        $log->LogDebug("x = 5");                    //Prints nothing due to level setting
*/

namespace NsFWK;

class ClsLogger {
    static private $_LoggerObject = null;

    private function __construct() { 
        return null;
    }

    static public function Init($arrConfig) {
        if(is_null(self::$_LoggerObject)){
            switch ($arrConfig['strLogStorage']){
                case "FILE":
                    $obj = new \NsFWK\ClsLoggerFile($arrConfig);
                    break;
            }
            self::$_LoggerObject = $obj;
        }
    }

    static public function GetInstance(){
        return self::$_LoggerObject;
    }
}