<?php
namespace NsFWK;

class ClsSmtpToGo {

    const SEND_ENDPOINT = '/email/send';
    private $_apiKey;
    private $_baseUrl;
    private $_sendUrl;

    public function __construct() {
        $this->_apiKey = SMTP2GO_API_KEY;
        $this->_baseUrl = SMTP2GO_API_URL;
        $this->_sendUrl = $this->_baseUrl . self::SEND_ENDPOINT;
    }

    public function Send(array $recipients, string $sender, int $templateId, array $templateVars, string $replyTo): bool {
        $payload = [
            'api_key' => $this->_apiKey,
            'to' => $recipients,
            'sender' => $sender,
            'template_id' => (string)$templateId,
            'template_data' => $templateVars,
            'custom_headers' => [['header' => 'Reply-To', 'value' => $replyTo]]
        ];

        $options = [
            'headers' => ['Content-Type' => 'application/json', 'Accept' => 'application/json'],
            'json' => $payload
        ];

        $client = new \GuzzleHttp\Client();
        $response = $client->post($this->_sendUrl, $options);

        $statusCode = $response->getStatusCode();
        $body = $response->getBody()->getContents();

        $responseData = json_decode($body, true);

        if (json_last_error() !== JSON_ERROR_NONE) {
            return false;
        }

        return $responseData['data']['succeeded'] ?? false;
    }

}
