<?php
namespace NsFWK;

Class ClsTime {
    private $_intMinutes = 0;
    private $_intSeconds = 0;
    private $_intMilliSeconds = 0;
    private $_strTime = '';
    private $_strTimeShort = '';
    
    private $_errorMsg = '';
    
    function __get($name){
        switch($name){
            case("intMinutes"):
                return $this->_intMinutes;
                break;
            case("intSeconds"):
                return $this->_intSeconds;
                break;
            case("intMilliSecond"):
                return $this->_intMilliSeconds;
                break;
            case("strTime"):
                return $this->_strTime;
                break;
            case("strTimeShort"):
                return $this->_strTimeShort;
                break;
            case("Error"):
                return $this->_errorMsg;
                break;
        }
        return false;
        
    }
    
    public function __construct($time){
        if (gettype($time)=="string"){
            $this->_strTime = $time;
            $rslt = $this->readTimeAsString();
        }else{
            $rslt = $this->readTimeFromMilliSecond($time);
        }
        return $rslt;
    }
    
    private function readTimeFromMilliSecond($decSecond){
        $intTimeMinutes = floor($decSecond/60);
        $intTimeSeconds = $decSecond % 60;
        $intTimeInSecAbs = $intTimeMinutes*60+$intTimeSeconds;
        $intMilliSeconds = (float)$decSecond - (float)$intTimeInSecAbs;
        $intMilliSeconds = number_format($intMilliSeconds,3);
        $this->_intMinutes = (int)$intTimeMinutes;
        $this->_intSeconds = (int)$intTimeSeconds;
        $this->_intMilliSeconds = $intMilliSeconds;
        $this->_strTime = str_pad($this->_intMinutes,2,"0",STR_PAD_LEFT). ":" .str_pad($this->_intSeconds,2,"0",STR_PAD_LEFT).".".str_pad($this->_intMilliSeconds*1000,3,"0",STR_PAD_LEFT);        
        $this->_strTimeShort = str_pad($this->_intMinutes,2,"0",STR_PAD_LEFT). ":" .str_pad($this->_intSeconds,2,"0",STR_PAD_LEFT);        
        return true;
    }
    
    private function readTimeAsString(){
        $arr = explode(":",$this->_strTime);
        if(count($arr)!=2){
            $this->_errorMsg = "Invalid time format, not in the format: 00:00.000";
            return false;
        }
        
        if(is_numeric($arr[0])==false){
            $this->_errorMsg = "The time format minutes part is not numeric";
        }else{
            $this->_intMinutes = (int)$arr[0];
        }
        
        $arrSecondPart = explode(".",$arr[1]);
        switch(true){
            case(count($arrSecondPart)==2):
                if (is_numeric($arrSecondPart[0]) && is_numeric($arrSecondPart[1])){
                    $this->_intSeconds = (int)$arrSecondPart[0];
                    $this->_intMilliSeconds = (float)$arrSecondPart[1];
                }else{
                    $this->_errorMsg = "The time format second part is not numeric";
                }
                break;
            case(count($arrSecondPart)==1):
                if (is_numeric($arrSecondPart[0])){
                    $this->_intSeconds = (int)$arrSecondPart[0];
                }
                break;
            default:
                break;
        }
        
        
    }
    
    public function ToArray(){
        $arrRslt = array();
        $arrRslt['intMinutes'] = (int)$this->_intMinutes;
        $arrRslt['intSeconds'] = (int)$this->_intSeconds;
        $arrRslt['intMilliSecond'] = (double)$this->_intMilliSecond;
        $arrRslt['strTime'] = (string)$this->_strTime;
        $arrRslt['strTimeShort'] = (string)$this->_strTimeShort;
        return $arrRslt;        
    }
    
    
    
    
}
